<!-- 编辑弹窗 -->
<template>
  <ele-modal
    :width="800"
    :visible="visible"
    :maskClosable="false"
    :maxable="maxable"
    :title="isUpdate ? '编辑' : '添加'"
    :body-style="{ paddingBottom: '28px' }"
    @update:visible="updateVisible"
    @ok="save"
  >
    <a-form
      ref="formRef"
      :model="form"
      :rules="rules"
      :label-col="styleResponsive ? { md: 4, sm: 5, xs: 24 } : { flex: '90px' }"
      :wrapper-col="
        styleResponsive ? { md: 19, sm: 19, xs: 24 } : { flex: '1' }
      "
    >
      <a-form-item label="关联分类id" name="cid">
        <a-input
          allow-clear
          placeholder="请输入关联分类id"
          v-model:value="form.cid"
        />
      </a-form-item>
      <a-form-item label="标题" name="title">
        <a-input
          allow-clear
          placeholder="请输入标题"
          v-model:value="form.title"
        />
      </a-form-item>
      <a-form-item label="缩略图" name="thumb">
        <a-input
          allow-clear
          placeholder="请输入缩略图"
          v-model:value="form.thumb"
        />
      </a-form-item>
      <a-form-item label="是否需要报名费：1需要，2不需要" name="isPrice">
        <a-input
          allow-clear
          placeholder="请输入是否需要报名费：1需要，2不需要"
          v-model:value="form.isPrice"
        />
      </a-form-item>
      <a-form-item label="活动报名开始时间" name="startTime">
        <a-input
          allow-clear
          placeholder="请输入活动报名开始时间"
          v-model:value="form.startTime"
        />
      </a-form-item>
      <a-form-item label="活动报名结束时间" name="endTime">
        <a-input
          allow-clear
          placeholder="请输入活动报名结束时间"
          v-model:value="form.endTime"
        />
      </a-form-item>
      <a-form-item label="报名费" name="price">
        <a-input
          allow-clear
          placeholder="请输入报名费"
          v-model:value="form.price"
        />
      </a-form-item>
      <a-form-item label="允许报名人数" name="count">
        <a-input
          allow-clear
          placeholder="请输入允许报名人数"
          v-model:value="form.count"
        />
      </a-form-item>
      <a-form-item label="已报名人数" name="num">
        <a-input
          allow-clear
          placeholder="请输入已报名人数"
          v-model:value="form.num"
        />
      </a-form-item>
      <a-form-item label="描述" name="desc">
        <a-input
          allow-clear
          placeholder="请输入描述"
          v-model:value="form.desc"
        />
      </a-form-item>
      <a-form-item label="详细内容" name="content">
        <a-input
          allow-clear
          placeholder="请输入详细内容"
          v-model:value="form.content"
        />
      </a-form-item>
      <a-form-item label="浏览量" name="views">
        <a-input
          allow-clear
          placeholder="请输入浏览量"
          v-model:value="form.views"
        />
      </a-form-item>
      <a-form-item label="是否显示：1显示，2不显示" name="isShow">
        <a-input
          allow-clear
          placeholder="请输入是否显示：1显示，2不显示"
          v-model:value="form.isShow"
        />
      </a-form-item>
      <a-form-item label="" name="updateTime">
        <a-input
          allow-clear
          placeholder="请输入"
          v-model:value="form.updateTime"
        />
      </a-form-item>
    </a-form>
  </ele-modal>
</template>

<script lang="ts" setup>
  import { ref, reactive, watch } from 'vue';
  import { Form, message } from 'ant-design-vue';
  import { assignObject, uuid } from 'ele-admin-pro';
  import { addThinkSignup, updateThinkSignup } from '@/api/think/thinkSignup';
  import { ThinkSignup } from '@/api/think/thinkSignup/model';
  import { useThemeStore } from '@/store/modules/theme';
  import { storeToRefs } from 'pinia';
  import { ItemType } from 'ele-admin-pro/es/ele-image-upload/types';
  import { FormInstance } from 'ant-design-vue/es/form';
  import { FileRecord } from '@/api/system/file/model';

  // 是否是修改
  const isUpdate = ref(false);
  const useForm = Form.useForm;
  // 是否开启响应式布局
  const themeStore = useThemeStore();
  const { styleResponsive } = storeToRefs(themeStore);

  const props = defineProps<{
    // 弹窗是否打开
    visible: boolean;
    // 修改回显的数据
    data?: ThinkSignup | null;
  }>();

  const emit = defineEmits<{
    (e: 'done'): void;
    (e: 'update:visible', visible: boolean): void;
  }>();

  // 提交状态
  const loading = ref(false);
  // 是否显示最大化切换按钮
  const maxable = ref(true);
  // 表格选中数据
  const formRef = ref<FormInstance | null>(null);
  const images = ref<ItemType[]>([]);

  // 用户信息
  const form = reactive<ThinkSignup>({
    id: undefined,
    cid: undefined,
    title: undefined,
    thumb: undefined,
    isPrice: undefined,
    startTime: undefined,
    endTime: undefined,
    price: undefined,
    count: undefined,
    num: undefined,
    desc: undefined,
    content: undefined,
    views: undefined,
    isShow: undefined,
    createTime: undefined,
    updateTime: undefined,
    thinkSignupId: undefined,
    thinkSignupName: '',
    status: 0,
    comments: '',
    sortNumber: 100
  });

  /* 更新visible */
  const updateVisible = (value: boolean) => {
    emit('update:visible', value);
  };

  // 表单验证规则
  const rules = reactive({
    thinkSignupName: [
      {
        required: true,
        type: 'string',
        message: '请填写名称',
        trigger: 'blur'
      }
    ]
  });

  const chooseImage = (data: FileRecord) => {
    images.value.push({
      uid: data.id,
      url: data.path,
      status: 'done'
    });
    form.image = data.path;
  };

  const onDeleteItem = (index: number) => {
    images.value.splice(index, 1);
    form.image = '';
  };

  const { resetFields } = useForm(form, rules);

  /* 保存编辑 */
  const save = () => {
    if (!formRef.value) {
      return;
    }
    formRef.value
      .validate()
      .then(() => {
        loading.value = true;
        const formData = {
          ...form
        };
        const saveOrUpdate = isUpdate.value ? updateThinkSignup : addThinkSignup;
        saveOrUpdate(formData)
          .then((msg) => {
            loading.value = false;
            message.success(msg);
            updateVisible(false);
            emit('done');
          })
          .catch((e) => {
            loading.value = false;
            message.error(e.message);
          });
      })
      .catch(() => {});
  };

  watch(
    () => props.visible,
    (visible) => {
      if (visible) {
        images.value = [];
        if (props.data) {
          assignObject(form, props.data);
          if(props.data.image){
            images.value.push({
              uid: uuid(),
              url: props.data.image,
              status: 'done'
            })
          }
          isUpdate.value = true;
        } else {
          isUpdate.value = false;
        }
      } else {
        resetFields();
      }
    },
    { immediate: true }
  );
</script>
